package infrastructure.client.accounts.adapter;

import application.exception.GatewayServiceException;
import application.port.input.command.CustomerAccountCommand;
import com.banesco.common.infraestructure.helpers.LoggerHelper;
import domain.model.CustomerAccount;
import domain.repository.ICustomerProductPort;
import infrastructure.client.accounts.api.CustomerAccountClient;
import infrastructure.mapper.CustomerAccountMapper;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.ws.rs.WebApplicationException;
import lombok.extern.slf4j.Slf4j;
import org.eclipse.microprofile.rest.client.inject.RestClient;

import java.util.List;

@Slf4j
@ApplicationScoped
public class CustomerProductAdapter implements ICustomerProductPort {

    private final CustomerAccountClient client;

    public CustomerProductAdapter(@RestClient CustomerAccountClient client) {
        this.client = client;
    }

    @Override
    public List<CustomerAccount> execute(CustomerAccountCommand command, String requestId) {
        try {
            log.debug(LoggerHelper.buildInfoPrivateRequest(requestId, "Adaptador: Mapeando Command a DTO para api-get-db2-accounts-client-v2"));
            var request = CustomerAccountMapper.toRequestDto(command);
            log.info(LoggerHelper.buildInfoPrivateRequest(requestId, "Llamando al servicio de api-get-db2-accounts-client-v2", request));

            var response = client.readCustomerProducts(requestId, request);
            log.info(LoggerHelper.buildInfoPrivateResponse(requestId, "Respuesta del servicio de api-get-db2-accounts-client-v2", response));

            // Validación de contrato: asegura que la respuesta no sea nula o inválida.
            if (response == null) {
                log.warn(LoggerHelper.buildError(requestId, "Respuesta invalida o nula del servicio de api-get-db2-accounts-client-v2"));
                throw new GatewayServiceException("Respuesta invalida del servicio externo de api-get-db2-accounts-client-v2");
            }

            return CustomerAccountMapper.toEntityList(response);
        } catch (WebApplicationException ex) {
            var errorResponse = ex.getResponse();
            var status = errorResponse.getStatus();
            String errorDetails;

            // Verifica si el Content-Type es HTML
            if (errorResponse.getMediaType() != null && errorResponse.getMediaType().toString().contains("text/html")) {
                errorDetails = "Se recibio una respuesta HTML no esperada del servicio.";
                log.error(LoggerHelper.buildError(requestId,
                        String.format("Error HTTP %s del servicio de api-get-db2-accounts-client-v2 %s", status, errorDetails)));
            } else {
                // Si no es HTML, probablemente es un error JSON que sí queremos ver.
                var errorBody = errorResponse.readEntity(String.class);

                // Aun así, es buena idea truncarlo por si es muy largo
                errorDetails = errorBody.substring(0, Math.min(errorBody.length(), 1000));
                log.error(LoggerHelper.buildError(requestId,
                        String.format("Error HTTP no manejado del servicio de api-get-db2-accounts-client-v2 Status: %s. Body: %s", status, errorDetails)));
            }

            throw new GatewayServiceException("Error en el servicio de api-get-db2-accounts-client-v2: " + errorDetails);
        } catch (RuntimeException ex) {
            // Captura errores de más bajo nivel (red, timeouts, host desconocido, etc.).
            log.error(LoggerHelper.buildError(
                    requestId,
                    String.format("Error de comunicacion con el servicio de api-get-db2-accounts-client-v2: %s", ex.getMessage())
            ));
            // Traduce el error técnico a una excepción de la aplicación.
            throw new GatewayServiceException("No se pudo comunicar con el servicio externo de api-get-db2-accounts-client-v2");
        }
    }
}